# Readme
This file explains how to compile and run the computation of the validity domain for a square wave x0. The code solves the values of parameters p1 and p2 that satisfy that the integral of the square wave x0 is greater than c2-p2 in the time window [0, p1]: 

On[0,p1]I x0 >= c2 − p2

# Compilation
In order to compile the CPP code, follow the following instructions.

1- Install Parma Polyhedra Library (PPL).
sudo apt install ppl-dev

2- Install C++ compiler.
sudo apt install g++

3- Install parsing and lexing tools.
sudo apt install bison
sudo apt install flex

4- Install the GNU Multiple Precision (GMP) Arithmetic Library.
sudo apt install libgmp-dev

5- Install make
sudo apt install make

6- Once inside the folder install and generate the binaries for the tools by running make.
make

Finally, install and link the libraries
g++ integral_negations.cpp -lppl -lgmp -lgmpxx

# Execution
In order to run the binary files, execute:
a.out <signal_filename.csv> <number_of_negations>

The first parameter is the path to a CSV file representing the signal. The second parameter is the number of times we negate the validity domain that satisfies the integral expression. If we negate the validity domain twice (i.e., not not vd), then we get the original validity domain (i.e., vd).